<?php
include 'ImageFunctions.php';
$mapID = $_REQUEST["map_id"];
global $wpdb;
global $current_user;
$current_user = wp_get_current_user();
$mapPointsTable = $wpdb->prefix . "easy2mapimg_map_points";
$mapsTable = $wpdb->prefix . "easy2mapimg_maps";
$successMsg = "";
$continue = true;

var_dump($_REQUEST);

if (isset($_FILES['zipfile'])) {

    if (isset($_FILES['zipfile']['error'])) {

        switch ($_FILES['zipfile']['error']) {
            case UPLOAD_ERR_OK:
                break;
            case UPLOAD_ERR_NO_FILE:
                $successMsg = "No file sent.";
                $continue = false;
                break;
            case UPLOAD_ERR_INI_SIZE:
                $successMsg = "The file size exceeded max permitted upload file size. Please edit the php.ini file to increase the permitted file upload size.";
                $continue = false;
                break;
            case UPLOAD_ERR_FORM_SIZE:
                $successMsg = "The file size exceeded max permitted upload file size. Please edit the php.ini file to increase the permitted file upload size.";
                $continue = false;
                break;
            default:
                break;
        }
    }

    // Check filesize here.
    //if ($_FILES['zipfile']['size'] > 1000000) {
    //    $successMsg = "The file size exceeded max permitted upload file size.";
    //    $continue = false;
    //}

    if ($continue) {

        $filename = $_FILES['zipfile']['name'];
        $source = $_FILES['zipfile']['tmp_name'];
        $name = explode('.', $filename);
        $target = WP_CONTENT_DIR . "/uploads/easy2map/images/extracted4/" . $mapID . "/";

        $okay = strtolower($name[count($name) - 1]) == 'zip' ? true : false;

        if (!$okay) {
            $successMsg = "Please choose a zip file.";
            $continue = false;
        }

        if ($continue) {

            //create target directory if it does not exist
            if (!file_exists($target)) {
                $oldumask = umask(0);
                mkdir($target, 0777, true);
                umask($oldumask);
            }

            $saved_file_location = $target . $filename;

            //attempt to save zip-file to target folder
            if (move_uploaded_file($source, $saved_file_location)) {

                $wpdb->query($wpdb->prepare("
                UPDATE $mapsTable
                SET isActive = 1
                WHERE ID = %s;", $mapID));

                //open the zip file
                $successfullUploads = openZip($target, $saved_file_location, $mapID);

                $successMsg = $successfullUploads . " geotagged images successfully imported.";
                $continue = false;
            } else {

                $successMsg = "1An error was encountered when attempting to upload the file.";
                $continue = false;
            }
        }
    }
}

function openZip($target, $zip_file, $mapID) {

    $count = 0;

    //try {

    if (file_exists($zip_file)) {

        $unzipDirectory = $target . "unzipped/";

        if (!file_exists($unzipDirectory)) {
            $oldumask = umask(0);
            mkdir($unzipDirectory, 0777, true);
            umask($oldumask);
        }

        if (($zip = zip_open($zip_file))) {
            if ($zip) {
                // For every file in the zip-packet
                while ($zip_entry = zip_read($zip)) {
                    // Open the entry
                    if (zip_entry_open($zip, $zip_entry, "r")) {
                        // The name of the file to save on the disk
                        $file_name = $unzipDirectory . zip_entry_name($zip_entry);

                        // Get the content of the zip entry
                        $fstream = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));

                        file_put_contents($file_name, $fstream);
                        // Set the rights
                        chmod($file_name, 0777);

                        if (exif_imagetype($file_name)) {
                            $count += uploadZippedImage($file_name, $mapID);
                        }

                        // Close the entry
                        zip_entry_close($zip_entry);
                    }
                }
                // Close the zip-file
                zip_close($zip);
            }
            //delete the zip-file
            unlink($zip_file);
        }
    }
    //} catch (Exception $e) {
    //}

    return $count;
}

function uploadZippedImage($uploadedFile, $mapID) {

    global $wpdb;
    global $current_user;
    $current_user = wp_get_current_user();
    $mapPointsTable = $wpdb->prefix . "easy2mapimg_map_points";
    $mapsTable = $wpdb->prefix . "easy2mapimg_maps";
    $imagesDirectory = WP_CONTENT_DIR . "/uploads/easy2map/images/pin_content/" . $mapID . "/";
    $imagesURL = WP_CONTENT_URL . "/uploads/easy2map/images/pin_content/" . $mapID . "/";
    $successfullyImported = 0;

    try {

        //extract image width and height
        list($width, $height, $type, $attr) = getimagesize($uploadedFile);

        //make upload directory if necessary
        if (!file_exists($imagesDirectory)) {
            $oldumask = umask(0);
            mkdir($imagesDirectory, 0777, true);
            umask($oldumask);
        }

        //get the image name
        $parts = explode('/', rtrim($uploadedFile, '/'));
        $imageName = array_pop($parts);

        //attempt to extract the image's location information
        $arrLatLng = extractLocationFromImageExif($uploadedFile);
        $lat = 0;
        $lng = 0;

        if (is_array($arrLatLng) && count($arrLatLng) == 2 && is_numeric($arrLatLng[0]) && is_numeric($arrLatLng[1])) {
            $lat = $arrLatLng[0];
            $lng = $arrLatLng[1];
        }

        //if not geotagged, DO NOT IMPORT
        if (intval($lat) != 0 && intval($lng) != 0) {

            //resize image as required
            $arrPhotoSize = explode(",", str_ireplace("px", "", $_REQUEST["photoSize"]));
            $arrSmallImage = resizeImage($imagesDirectory, $uploadedFile, $imageName, $width, $height, $type, '25', '25', "SMALL", false);
            $imagePlusLocation_Small = $imagesURL . $arrSmallImage[0];

            $arrMediumImage = resizeImage($imagesDirectory, $uploadedFile, $imageName, $width, $height, $type, '90', '90', "MEDIUM", false);
            $imagePlusLocation_Medium = $imagesURL . $arrMediumImage[0];

            $arrLargeImage = resizeImage($imagesDirectory, $uploadedFile, $imageName, $width, $height, $type, $arrPhotoSize[0], $arrPhotoSize[1], "LARGE", true);
            $imagePlusLocation_Large = $imagesURL . $arrLargeImage[0];

            //insert record of image into database
            $SQL = $wpdb->prepare("
            INSERT INTO $mapPointsTable(
                MapID
                ,CreatedByUserID
                ,LatLong
                ,Title
                ,PinImageURL
                ,Settings
                ,DetailsHTML
                ,DetailsText
                ,PinImageSmall 
                ,PinImageMedium
                ,PinImageLarge
            ) SELECT ID, %s, '%s', '%s', 
                DefaultPinImage, '%s', '%s', 
                '%s', '%s', '%s', '%s' 
                FROM $mapsTable
            WHERE ID = %s;", $current_user->ID, $lat . "," . $lng, '', '', '', '', $imagePlusLocation_Small, $imagePlusLocation_Medium, $imagePlusLocation_Large, $mapID);

            $wpdb->query($SQL);
            $successfullyImported = 1;
        }

        //delete image file
        unlink($uploadedFile);
    } catch (Exception $e) {
        
    }

    return $successfullyImported;
}

if (strlen($successMsg) > 0) {
    ?>
    <script>
        window.parent.easy2map_imgmappin_functions.uploadZippedFileResult('<?php echo $successMsg; ?>');
    </script>

<?php } ?>
